﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Activities;
using System.Activities.Statements;

// Demo by Raffaele Rialdi. May 20, 2010
// http://www.iamraf.net
// malta@vevy.com

namespace StateMachineUI
{
	public partial class Form1 : Form
	{
		WorkflowApplication _wf;

		public Form1()
		{
			InitializeComponent();

			var pars = new Dictionary<string, object>()
			{
				{ "UI", this },
			};
			_wf = new WorkflowApplication(new UIState(), pars);
			_wf.Run();
		}

		protected override void OnClosed(EventArgs e)
		{
			_wf.Terminate("Quitting...");
			base.OnClosed(e);
		}


		public void FromWorkflowProc(string State)
		{
			this.Invoke(() =>
				{
					int index = lbMessage.Items.Add(State);
					lbMessage.SelectedIndex = index;

					switch(State)
					{
						case "Wait":
							btInsert.Enabled = true;
							btEdit.Enabled = true;
							btDelete.Enabled = true;
							btSave.Enabled = false;
							btCancel.Enabled = false;
							break;
						case "Edit":
							btInsert.Enabled = false;
							btEdit.Enabled = false;
							btDelete.Enabled = false;
							btSave.Enabled = true;
							btCancel.Enabled = true;
							break;
						case "Insert":
							btInsert.Enabled = false;
							btEdit.Enabled = true;
							btDelete.Enabled = false;
							btSave.Enabled = true;
							btCancel.Enabled = true;
							break;
					}
				});
		}

		private void btInsert_Click(object sender, EventArgs e)
		{
			_wf.ResumeBookmark(StateInfoActivity.StateUnlocker, "Insert");
		}

		private void btEdit_Click(object sender, EventArgs e)
		{
			_wf.ResumeBookmark(StateInfoActivity.StateUnlocker, "Edit");
		}

		private void btDelete_Click(object sender, EventArgs e)
		{
			_wf.ResumeBookmark(StateInfoActivity.StateUnlocker, "Delete");
		}

		private void btSave_Click(object sender, EventArgs e)
		{
			_wf.ResumeBookmark(StateInfoActivity.StateUnlocker, "Save");
		}

		private void btCancel_Click(object sender, EventArgs e)
		{
			_wf.ResumeBookmark(StateInfoActivity.StateUnlocker, "Cancel");
		}

	}

	public static class RafExtension
	{
		public static void Invoke(this Control Control, Action Action)
		{
			Control.Invoke(Action);
		}
	}


}
